/* Problem URL: https://codeforces.com/contest/2146/problem/D2 */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        V<array<int, 2>> trie(1);
        V<array<int, 2>> count(1);

        auto add = [&](ll num) {
            int now = 0;
            rep(i, 31) {
                int bit = (num >> i) & 1;
                count[now][bit]++;
                if (trie[now][bit] == 0) {
                    trie[now][bit] = trie.size();
                    count.emplace_back();
                    trie.emplace_back();
                }

                now = trie[now][bit];
            }
        };

        auto rem = [&](ll num) {
            int now = 0;
            rep(i, 31) {
                int bit = (num >> i) & 1;
                count[now][bit]--;
                now = trie[now][bit];
            }
        };

        ll l, r;
        cin >> l >> r;

        nrep(i, l, r + 1) {
            add(i);
        }

        int n = r - l + 1;
        vl ans(n);

        for (int i = r; i >= l; i--) {
            ll tmp = 0;
            function<void(int, int)> find = [&](ll now, int j) {
                if (j > 30) {
                    return;
                }

                int bit = (i >> j) & 1;
                if (count[now][bit^1] == 0) {
                    tmp |= (bit << j);
                    find(trie[now][bit], j + 1);
                    return;
                }

                tmp |= ((bit^1) << j);
                find(trie[now][bit^1], j + 1);
            };

            find(0, 0);

            rem(tmp);
            ans[i - l] = tmp;
        }

        ll total = 0;
        rep(i, n) {
            total += ans[i] | (i + l);
        }

        cout << total << '\n';
        cout << ans;
    }
}
